#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TherionTreasureCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TherionTreasureCFG> Fish_TherionTreasureCFG::msSingleton(nullptr);

int Fish_TherionTreasureCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TherionTreasureCFGData* Fish_TherionTreasureCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TherionTreasureCFGData>& Fish_TherionTreasureCFG::GetMapData()
{
	return mMapData;
}

void Fish_TherionTreasureCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TherionTreasureCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TherionTreasureCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mDrawType = element->IntAttribute("DrawType");
		{
			const char* RosefinchRate = element->Attribute("RosefinchRate");
			std::vector<std::string> vecRosefinchRate;
			boost::split(vecRosefinchRate, RosefinchRate, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRosefinchRate.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRosefinchRate[i].c_str(), &temp))
				{
					data.mRosefinchRate.push_back(temp);
				}
			}
		}
		data.mRosefinchWeight = element->IntAttribute("RosefinchWeight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TherionTreasureCFG::Load()
{
	Load("../Config/Fish_TherionTreasureCFG.xml");
}

Fish_TherionTreasureCFG* Fish_TherionTreasureCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TherionTreasureCFG());
	}
	return msSingleton.get();
}
